#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include "khpc0.h"

char persistent_init_flg = 0;
char persistent_load_flg = 0;

int persistent_tmpFileNum = 0;

#define persistent_IDMAXLEN		256
#define persistent_TABLEMAXSIZ	256
#define persistent_MAXGRPS		16
#define persistent_PATHMAXLEN	1024

struct persistent_TableStr {
	void *p;
	int siz, flgs, grpId;
	unsigned char id[persistent_IDMAXLEN];
	unsigned char typ[persistent_IDMAXLEN];
	unsigned char rem[persistent_IDMAXLEN];
};

struct persistent_GrpStr {
	unsigned char path[persistent_PATHMAXLEN];
	unsigned char tmp [persistent_PATHMAXLEN];
	unsigned char memo[persistent_PATHMAXLEN];
	int grpId, flgs;
};

// pesistent-binary-data.

struct persistent_GrpStr persistent_grpTable[persistent_MAXGRPS];
struct persistent_TableStr persistent_table[persistent_TABLEMAXSIZ];
int persistent_table_siz1 = persistent_TABLEMAXSIZ;
int persistent_table_siz = 0;

void persistent_default();

void persistent_init()
{
	if (persistent_init_flg != 0) goto fin;
	persistent_default();

	persistent_init_flg = 1;
fin:
	return;
}

char persistent_fgets(unsigned char *s, FILE *fp)
{
	int i, c;
	char r = 0;
	for (i = 0; i < persistent_IDMAXLEN; i++) {
		c = fgetc(fp);
		if (c == EOF) {
			r = 1;
			break;
		}
		s[i] = c;
		if (c == '\0') break;
	}
	if (i == persistent_IDMAXLEN)
		r = 2;
	return r;
}

int persistent_fputs(unsigned char *s, FILE *fp)
{
	return fwrite(s, 1, strlen(s) + 1, fp);
}

int persistent_getSizFlgsId(FILE *fp, int *flgs, unsigned char *id, const char *funcName)
{
	int siz, r;
	if (fread(&siz, 1, 4, fp) != 4) {
		fprintf(stderr, "persistent_%s: file format error (1)\n", funcName);
		exit(1);
	}
	if (siz != 0) {
		if (fread(flgs, 1, 4, fp) != 4) {
			fprintf(stderr, "persistent_%s: file format error (2)\n", funcName);
			exit(1);
		}
		r = persistent_fgets(id, fp);
		if (r == 1) {
			fprintf(stderr, "persistent_%s: file format error (3)\n", funcName);
			exit(1);
		}
		if (r == 2) {
			fprintf(stderr, "persistent_%s: too long id in file: %.64s...\n", funcName, id);
			exit(1);
		}
	}
	return siz;
}

void persistent_save0(struct persistent_GrpStr *grp)
{
	int siz, flgs, i, c;
	unsigned char id[persistent_IDMAXLEN];
	char tmp[persistent_IDMAXLEN];

	sprintf(tmp, grp->tmp, persistent_tmpFileNum);
	FILE *fpr = fopen(grp->path, "rb");
	FILE *fpw = fopen(tmp, "wb");
	persistent_fputs("persistent_binary_memimage_IA32_v00", fpw);
	persistent_fputs(grp->memo, fpw);
	if (fpr != NULL) {
		persistent_fgets(id, fpr); // format̓ǂݔ΂. 蔲ŃG[񍐂Ȃ.
		persistent_fgets(id, fpr); // note̓ǂݔ΂.
		for (;;) {
			/* ܂֌W̕ϐRs[ */
			siz = persistent_getSizFlgsId(fpr, &flgs, id, "save");
			if (siz == 0) break;
			for (i = 0; i < persistent_table_siz; i++) {
				if (persistent_table[i].grpId == grp->grpId && strcmp(id, persistent_table[i].id) == 0)
					break;
			}
			if (i < persistent_table_siz) {
				/* ɂ݂̂łЂƂ܂ǂݔ΂ */
				if (fseek(fpr, (long) siz, SEEK_CUR) != 0) {
					fprintf(stderr, "persistent_save: file format error (4)\n");
					exit(1);
				}
			} else {
				/* ɂ͂Ȃ̂ŃRs[ */
				fwrite(&siz,  1, 4, fpw);
				fwrite(&flgs, 1, 4, fpw);
				persistent_fputs(id, fpw);
				for (i = 0; i < siz; i++) {
					c = fgetc(fpr);
					if (c == EOF) {
						fprintf(stderr, "persistent_save: file format error (5)\n");
						exit(1);
					}
					fputc(c, fpw);
				}
			}
		}
		fclose(fpr);
	}
	/* Ƀ̓eZ[u */
	for (i = 0; i < persistent_table_siz; i++) {
		if (persistent_table[i].grpId != grp->grpId) continue;
		if (persistent_table[i].p == NULL) continue; // o͂Ȃ. 폜p.
		fwrite(&persistent_table[i].siz,  1, 4, fpw);
		fwrite(&persistent_table[i].flgs, 1, 4, fpw);
		persistent_fputs(persistent_table[i].id, fpw);
		fwrite(persistent_table[i].p, 1, persistent_table[i].siz, fpw);
	}
	siz = 0;
	fwrite(&siz, 1, 4, fpw); // I[}[N.
	fclose(fpw);	// fpwcloseăobt@fĂ狌t@C(Ŝ).
		// ݓrdisk-fullȂǂɂȂꍇ͍lĂȂ(蔲).
	for (;;) {
		i = rename(tmp, grp->path);
		if (i == 0) break;
		remove(grp->path);
	} while (i != 0);
	return;
}

int persistent_save(double t)
{
	static clock_t t0 = 0;
	int r = 0, i;
	clock_t t1 = clock();
	if (persistent_load_flg == 0) {
		fprintf(stderr, "persistent_save: no loading error\n");
		exit(1);
	}
	if (t0 == 0 || ((double) (t1 - t0)) >= t * CLOCKS_PER_SEC) {
		t0 = t1;
		for (i = 0; i < persistent_MAXGRPS; i++) {
			if (persistent_grpTable[i].path[0] == '\0') continue;
			if ((persistent_grpTable[i].flgs & persistent_FLG_NOSAVE) != 0) continue;
			persistent_save0(&persistent_grpTable[i]);
		}
		r = -1;
	}
	return r;
}

void persistent_load0(struct persistent_GrpStr *grp)
{
	FILE *fp = fopen(grp->path, "rb");
	int siz, flgs, i, c;
	unsigned char id[persistent_IDMAXLEN];
	if (fp != NULL) {
		do {
			c = fgetc(fp);
			if (c == EOF) break;
		} while (c != '\0');
		do {
			c = fgetc(fp);
			if (c == EOF) break;
		} while (c != '\0');
		for (;;) {
			siz = persistent_getSizFlgsId(fp, &flgs, id, "load");
			if (siz == 0) break;
			for (i = 0; i < persistent_table_siz; i++) {
				if (persistent_table[i].grpId == grp->grpId && strcmp(id, persistent_table[i].id) == 0)
					break;
			}
			if (i < persistent_table_siz) {
				if (persistent_table[i].siz >= siz) {
					if (fread(persistent_table[i].p, 1, siz, fp) != siz) {
						fprintf(stderr, "persistent_load: file format error (5)\n");
						exit(1);
					}
				} else {
					/* k[h */
					if (fread(persistent_table[i].p, 1, persistent_table[i].siz, fp) != persistent_table[i].siz) {
						fprintf(stderr, "persistent_load: file format error (6)\n");
						exit(1);
					}
					siz -= persistent_table[i].siz;
					for (i = 0; i < siz; i++) {
						c = fgetc(fp);
						if (c == EOF) {
							fprintf(stderr, "persistent_load: file format error (7)\n");
							exit(1);
						}
						if (c != '\0') {
							fprintf(stderr, "persistent_load: data size error: %s\n", id);
							exit(1);
						}
					}
				}
			} else {
				/* ɂ݂͑Ȃ̂łЂƂ܂ǂݔ΂ */
				if (fseek(fp, siz, SEEK_CUR) != 0) {
					fprintf(stderr, "persistent_load: file format error (4)\n");
					exit(1);
				}
			}
		}
		fclose(fp);
	}
	return;
}

void persistent_checkGrp()
{
	int i, j;
	for (i = 0; i < persistent_table_siz; i++) {
		for (j = 0; j < persistent_MAXGRPS; j++) {
			if (persistent_table[i].grpId == persistent_grpTable[j].grpId && persistent_grpTable[j].path[0] != '\0')
				break;
		}
		if (j >= persistent_MAXGRPS) {
			fprintf(stderr, "persistent_checkGrp: invalid grpId: %s\n", persistent_table[i].id);
			exit(1);
		}
	}
	return;
}

void persistent_noload()
/* ͂邪A[h͂Ȃ */
{
	if (persistent_init_flg == 0)
		persistent_init();
	if (persistent_load_flg == 0) {
		persistent_checkGrp();
		persistent_load_flg = 1;
	}
	return;
}

int persistent_load(double t)
{
	static clock_t t0 = 0;
	int r = 0, i;
	clock_t t1 = clock();
	persistent_noload();
	if (t0 == 0 || ((double) (t1 - t0)) >= t * CLOCKS_PER_SEC) {
		t0 = t1;
		for (i = 0; i < persistent_MAXGRPS; i++) {
			if (persistent_grpTable[i].path[0] == '\0') continue;
			if ((persistent_grpTable[i].flgs & persistent_FLG_NOLOAD) != 0) continue;
			persistent_load0(&persistent_grpTable[i]);
		}
		r = -1;
	}
	return r;
}


void persistent_grp(int grpId, const char *path, const char *tmp, const char *memo)
{
	int i;
	if (persistent_load_flg != 0) {
		fprintf(stderr, "persistent_grp: setting after load: grpId=%d\n", grpId);
		exit(1);
	}
	if (path == NULL || *path == '\0') {
		fprintf(stderr, "persistent_grp: invalid path: grpId=%d\n", grpId);
		exit(1);
	}
	if (tmp == NULL  || *tmp  == '\0') {
		fprintf(stderr, "persistent_grp: invalid tmp: grpId=%d\n", grpId);
		exit(1);
	}
	if (strlen(path) >= persistent_PATHMAXLEN) {
		fprintf(stderr, "persistent_grp: too long path: grpId=%d\n", grpId);
		exit(1);
	}
	if (strlen(tmp)  >= persistent_PATHMAXLEN) {
		fprintf(stderr, "persistent_grp: too long tmp: grpId=%d\n", grpId);
		exit(1);
	}
	if (memo != NULL && strlen(memo) >= persistent_PATHMAXLEN) {
		fprintf(stderr, "persistent_grp: too long memo: grpId=%d\n", grpId);
		exit(1);
	}
	if (strcmp(path, tmp) == 0) {
		fprintf(stderr, "persistent_grp: path == tmp: grpId=%d\n", grpId);
		exit(1);
	}
	if (grpId == 256 && persistent_grpTable[0].grpId == 256 && persistent_grpTable[0].path[0] != '\0') {
		persistent_grpTable[0].path[0] = '\0'; // ftHgݒ㏑j[YɑΉ.
	}
	for (i = 0; i < persistent_MAXGRPS; i++) {
		if (grpId == persistent_grpTable[i].grpId && persistent_grpTable[i].path[0] != '\0')
			break;
	}
	if (i < persistent_MAXGRPS) {
		fprintf(stderr, "persistent_grp: redefine grpId: %s\n", path);
		exit(1);
	}
	for (i = 0; i < persistent_MAXGRPS; i++) {
		if (persistent_grpTable[i].path[0] == '\0')
			break;
	}
	if (i >= persistent_MAXGRPS) {
		fprintf(stderr, "persistent_grp: too many grps: %s\n", path);
		exit(1);
	}
	persistent_grpTable[i].grpId = grpId;
	strcpy(persistent_grpTable[i].path, path);	// lenlׂ.
	strcpy(persistent_grpTable[i].tmp,  tmp);	// lenlׂ.
	strcpy(persistent_grpTable[i].memo, "_");
	if (memo != NULL)
		strcpy(persistent_grpTable[i].memo, memo);	// lenlׂ.
	persistent_grpTable[i].flgs = 0;
	return;
}

void persistent_def(void *p, int size, int grpId, const char *id)
{
	int i;
	if (*id == '\0') {
		fprintf(stderr, "persistent_def: strlen(id) == 0\n", id);
		exit(1);
	}
	if (strlen(id) >= persistent_IDMAXLEN) {
		fprintf(stderr, "persistent_def: too long id: %.64s...\n", id);
		exit(1);
	}
	if (persistent_load_flg != 0) {
		fprintf(stderr, "persistent_def: setting after load: %s\n", id);
		exit(1);
	}
	if (size <= 0 && p != NULL) {
		fprintf(stderr, "persistent_def: size <= 0: %s\n", id);
		exit(1);
	}
	/* p == NULL͕sł͂ȂB폜邽߂ɎgB */
	for (i = 0; i < persistent_table_siz; i++) {
		if (strcmp(id, persistent_table[i].id) == 0)
			break;
	}
	if (i < persistent_table_siz) {
		fprintf(stderr, "persistent_def: redefine id: %s\n", id);
		exit(1);
	}
	if (persistent_table_siz >= persistent_table_siz1) {
		fprintf(stderr, "persistent_def: internal table full: %s\n", id);
		exit(1);
		/* ̏ꍇAG[Nid͏dvł͂ȂBǂ܂ł󂯓ꂽ̖ڈxB */
	}
	i = persistent_table_siz;
	persistent_table_siz++;
	strcpy(persistent_table[i].id, id);
	persistent_table[i].p = p;
	persistent_table[i].siz = size;
	persistent_table[i].grpId = grpId;
	persistent_table[i].flgs = 0;
	return;
}

void persistent_optGrpFlgs(int grpId, int flgs)
{
	int i;
	for (i = 0; i < persistent_MAXGRPS; i++) {
		if (grpId == persistent_grpTable[i].grpId)
			break;
	}
	if (i >= persistent_MAXGRPS) {
		fprintf(stderr, "persistent_optFlgs: invalid grpId: grpId=%d\n", grpId);
		exit(1);
	}
	persistent_table[i].flgs = flgs;
	return;
}

void persistent_setTmpFileNum(int i)
{
	persistent_tmpFileNum = i;
	return;
}

// ȉ̊֐́Ão[Wŗpӂ.
void persistent_optFlgs(int grpId, const char *id, int flgs);
void persistent_optTyp(int grpId, const char *id, const char *typ);
void persistent_optRem(int grpId, const char *id, const char *rem);
